#ifndef _MFERROR_H
#define _MFERROR_H

#define STATUS_SEVERITY(hr)  (((hr) >> 30) & 0x3)

#define _HRESULT_TYPEDEF_(_sc)  ((HRESULT)_sc)

#define FACILITY_MF_WIN32  0x7
#define FACILITY_MF  0xD

#define STATUS_SEVERITY_WARNING  0x2
#define STATUS_SEVERITY_SUCCESS  0x0
#define STATUS_SEVERITY_INFORMATIONAL  0x1
#define STATUS_SEVERITY_ERROR  0x3

#define MF_E_PLATFORM_NOT_INITIALIZED  _HRESULT_TYPEDEF_(0xC00D36B0L)
#define MF_E_BUFFERTOOSMALL  _HRESULT_TYPEDEF_(0xC00D36B1L)
#define MF_E_INVALIDREQUEST  _HRESULT_TYPEDEF_(0xC00D36B2L)
#define MF_E_INVALIDSTREAMNUMBER  _HRESULT_TYPEDEF_(0xC00D36B3L)
#define MF_E_INVALIDMEDIATYPE  _HRESULT_TYPEDEF_(0xC00D36B4L)
#define MF_E_NOTACCEPTING  _HRESULT_TYPEDEF_(0xC00D36B5L)
#define MF_E_NOT_INITIALIZED  _HRESULT_TYPEDEF_(0xC00D36B6L)
#define MF_E_UNSUPPORTED_REPRESENTATION  _HRESULT_TYPEDEF_(0xC00D36B7L)
#define MF_E_NO_MORE_TYPES  _HRESULT_TYPEDEF_(0xC00D36B9L)
#define MF_E_UNSUPPORTED_SERVICE  _HRESULT_TYPEDEF_(0xC00D36BAL)
#define MF_E_UNEXPECTED  _HRESULT_TYPEDEF_(0xC00D36BBL)
#define MF_E_INVALIDNAME  _HRESULT_TYPEDEF_(0xC00D36BCL)
#define MF_E_INVALIDTYPE  _HRESULT_TYPEDEF_(0xC00D36BDL)
#define MF_E_INVALID_FILE_FORMAT  _HRESULT_TYPEDEF_(0xC00D36BEL)
#define MF_E_INVALIDINDEX  _HRESULT_TYPEDEF_(0xC00D36BFL)
#define MF_E_INVALID_TIMESTAMP  _HRESULT_TYPEDEF_(0xC00D36C0L)
#define MF_E_UNSUPPORTED_SCHEME  _HRESULT_TYPEDEF_(0xC00D36C3L)
#define MF_E_UNSUPPORTED_BYTESTREAM_TYPE _HRESULT_TYPEDEF_(0xC00D36C4L)
#define MF_E_UNSUPPORTED_TIME_FORMAT  _HRESULT_TYPEDEF_(0xC00D36C5L)
#define MF_E_NO_SAMPLE_TIMESTAMP  _HRESULT_TYPEDEF_(0xC00D36C8L)
#define MF_E_NO_SAMPLE_DURATION  _HRESULT_TYPEDEF_(0xC00D36C9L)
#define MF_E_INVALID_STREAM_DATA  _HRESULT_TYPEDEF_(0xC00D36CBL)
#define MF_E_RT_UNAVAILABLE  _HRESULT_TYPEDEF_(0xC00D36CFL)
#define MF_E_UNSUPPORTED_RATE  _HRESULT_TYPEDEF_(0xC00D36D0L)
#define MF_E_THINNING_UNSUPPORTED  _HRESULT_TYPEDEF_(0xC00D36D1L)
#define MF_E_REVERSE_UNSUPPORTED  _HRESULT_TYPEDEF_(0xC00D36D2L)
#define MF_E_UNSUPPORTED_RATE_TRANSITION _HRESULT_TYPEDEF_(0xC00D36D3L)
#define MF_E_RATE_CHANGE_PREEMPTED  _HRESULT_TYPEDEF_(0xC00D36D4L)
#define MF_E_NOT_FOUND  _HRESULT_TYPEDEF_(0xC00D36D5L)
#define MF_E_NOT_AVAILABLE  _HRESULT_TYPEDEF_(0xC00D36D6L)
#define MF_E_NO_CLOCK  _HRESULT_TYPEDEF_(0xC00D36D7L)
#define MF_S_MULTIPLE_BEGIN  _HRESULT_TYPEDEF_(0x000D36D8L)
#define MF_E_MULTIPLE_BEGIN  _HRESULT_TYPEDEF_(0xC00D36D9L)
#define MF_E_MULTIPLE_SUBSCRIBERS  _HRESULT_TYPEDEF_(0xC00D36DAL)
#define MF_E_TIMER_ORPHANED  _HRESULT_TYPEDEF_(0xC00D36DBL)
#define MF_E_STATE_TRANSITION_PENDING  _HRESULT_TYPEDEF_(0xC00D36DCL)
#define MF_E_UNSUPPORTED_STATE_TRANSITION _HRESULT_TYPEDEF_(0xC00D36DDL)
#define MF_E_UNRECOVERABLE_ERROR_OCCURRED _HRESULT_TYPEDEF_(0xC00D36DEL)
#define MF_E_SAMPLE_HAS_TOO_MANY_BUFFERS _HRESULT_TYPEDEF_(0xC00D36DFL)
#define MF_E_SAMPLE_NOT_WRITABLE  _HRESULT_TYPEDEF_(0xC00D36E0L)
#define MF_E_INVALID_KEY  _HRESULT_TYPEDEF_(0xC00D36E2L)
#define MF_E_BAD_STARTUP_VERSION  _HRESULT_TYPEDEF_(0xC00D36E3L)
#define MF_E_UNSUPPORTED_CAPTION  _HRESULT_TYPEDEF_(0xC00D36E4L)
#define MF_E_INVALID_POSITION  _HRESULT_TYPEDEF_(0xC00D36E5L)
#define MF_E_ATTRIBUTENOTFOUND  _HRESULT_TYPEDEF_(0xC00D36E6L)
#define MF_E_PROPERTY_TYPE_NOT_ALLOWED  _HRESULT_TYPEDEF_(0xC00D36E7L)
#define MF_E_PROPERTY_TYPE_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC00D36E8L)
#define MF_E_PROPERTY_EMPTY  _HRESULT_TYPEDEF_(0xC00D36E9L)
#define MF_E_PROPERTY_NOT_EMPTY  _HRESULT_TYPEDEF_(0xC00D36EAL)
#define MF_E_PROPERTY_VECTOR_NOT_ALLOWED _HRESULT_TYPEDEF_(0xC00D36EBL)
#define MF_E_PROPERTY_VECTOR_REQUIRED  _HRESULT_TYPEDEF_(0xC00D36ECL)
#define MF_E_OPERATION_CANCELLED  _HRESULT_TYPEDEF_(0xC00D36EDL)
#define MF_E_BYTESTREAM_NOT_SEEKABLE  _HRESULT_TYPEDEF_(0xC00D36EEL)
#define MF_E_DISABLED_IN_SAFEMODE  _HRESULT_TYPEDEF_(0xC00D36EFL)
#define MF_E_CANNOT_PARSE_BYTESTREAM  _HRESULT_TYPEDEF_(0xC00D36F0L)
#define MF_E_SOURCERESOLVER_MUTUALLY_EXCLUSIVE_FLAGS _HRESULT_TYPEDEF_(0xC00D36F1L)
#define MF_E_MEDIAPROC_WRONGSTATE  _HRESULT_TYPEDEF_(0xC00D36F2L)
#define MF_E_RT_THROUGHPUT_NOT_AVAILABLE _HRESULT_TYPEDEF_(0xC00D36F3L)
#define MF_E_RT_TOO_MANY_CLASSES  _HRESULT_TYPEDEF_(0xC00D36F4L)
#define MF_E_RT_WOULDBLOCK  _HRESULT_TYPEDEF_(0xC00D36F5L)
#define MF_E_NO_BITPUMP  _HRESULT_TYPEDEF_(0xC00D36F6L)
#define MF_E_RT_OUTOFMEMORY  _HRESULT_TYPEDEF_(0xC00D36F7L)
#define MF_E_RT_WORKQUEUE_CLASS_NOT_SPECIFIED _HRESULT_TYPEDEF_(0xC00D36F8L)
#define MF_E_INSUFFICIENT_BUFFER  _HRESULT_TYPEDEF_(0xC00D7170L)
#define MF_E_CANNOT_CREATE_SINK  _HRESULT_TYPEDEF_(0xC00D36FAL)
#define MF_E_BYTESTREAM_UNKNOWN_LENGTH  _HRESULT_TYPEDEF_(0xC00D36FBL)
#define MF_E_SESSION_PAUSEWHILESTOPPED  _HRESULT_TYPEDEF_(0xC00D36FCL)
#define MF_S_ACTIVATE_REPLACED  _HRESULT_TYPEDEF_(0x000D36FDL)
#define MF_E_FORMAT_CHANGE_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC00D36FEL)
#define MF_E_INVALID_WORKQUEUE  _HRESULT_TYPEDEF_(0xC00D36FFL)
#define MF_E_DRM_UNSUPPORTED  _HRESULT_TYPEDEF_(0xC00D3700L)
#define MF_E_UNAUTHORIZED  _HRESULT_TYPEDEF_(0xC00D3701L)
#define MF_E_OUT_OF_RANGE  _HRESULT_TYPEDEF_(0xC00D3702L)
#define MF_E_INVALID_CODEC_MERIT  _HRESULT_TYPEDEF_(0xC00D3703L)
#define MF_E_HW_MFT_FAILED_START_STREAMING _HRESULT_TYPEDEF_(0xC00D3704L)

#define MF_S_ASF_PARSEINPROGRESS  _HRESULT_TYPEDEF_(0x400D3A98L)

#define MF_E_ASF_PARSINGINCOMPLETE  _HRESULT_TYPEDEF_(0xC00D3A98L)
#define MF_E_ASF_MISSINGDATA  _HRESULT_TYPEDEF_(0xC00D3A99L)
#define MF_E_ASF_INVALIDDATA  _HRESULT_TYPEDEF_(0xC00D3A9AL)
#define MF_E_ASF_OPAQUEPACKET  _HRESULT_TYPEDEF_(0xC00D3A9BL)
#define MF_E_ASF_NOINDEX  _HRESULT_TYPEDEF_(0xC00D3A9CL)
#define MF_E_ASF_OUTOFRANGE  _HRESULT_TYPEDEF_(0xC00D3A9DL)
#define MF_E_ASF_INDEXNOTLOADED  _HRESULT_TYPEDEF_(0xC00D3A9EL)  
#define MF_E_ASF_TOO_MANY_PAYLOADS  _HRESULT_TYPEDEF_(0xC00D3A9FL)  
#define MF_E_ASF_UNSUPPORTED_STREAM_TYPE _HRESULT_TYPEDEF_(0xC00D3AA0L)  
#define MF_E_ASF_DROPPED_PACKET  _HRESULT_TYPEDEF_(0xC00D3AA1L)  

#define MF_E_NO_EVENTS_AVAILABLE  _HRESULT_TYPEDEF_(0xC00D3E80L)
#define MF_E_INVALID_STATE_TRANSITION  _HRESULT_TYPEDEF_(0xC00D3E82L)
#define MF_E_END_OF_STREAM  _HRESULT_TYPEDEF_(0xC00D3E84L)
#define MF_E_SHUTDOWN  _HRESULT_TYPEDEF_(0xC00D3E85L)
#define MF_E_MP3_NOTFOUND  _HRESULT_TYPEDEF_(0xC00D3E86L)
#define MF_E_MP3_OUTOFDATA  _HRESULT_TYPEDEF_(0xC00D3E87L)
#define MF_E_MP3_NOTMP3  _HRESULT_TYPEDEF_(0xC00D3E88L)
#define MF_E_MP3_NOTSUPPORTED  _HRESULT_TYPEDEF_(0xC00D3E89L)
#define MF_E_NO_DURATION  _HRESULT_TYPEDEF_(0xC00D3E8AL)
#define MF_E_INVALID_FORMAT  _HRESULT_TYPEDEF_(0xC00D3E8CL)
#define MF_E_PROPERTY_NOT_FOUND  _HRESULT_TYPEDEF_(0xC00D3E8DL)
#define MF_E_PROPERTY_READ_ONLY  _HRESULT_TYPEDEF_(0xC00D3E8EL)
#define MF_E_PROPERTY_NOT_ALLOWED  _HRESULT_TYPEDEF_(0xC00D3E8FL)
#define MF_E_MEDIA_SOURCE_NOT_STARTED  _HRESULT_TYPEDEF_(0xC00D3E91L)
#define MF_E_UNSUPPORTED_FORMAT  _HRESULT_TYPEDEF_(0xC00D3E98L)
#define MF_E_MP3_BAD_CRC  _HRESULT_TYPEDEF_(0xC00D3E99L)
#define MF_E_NOT_PROTECTED  _HRESULT_TYPEDEF_(0xC00D3E9AL)
#define MF_E_MEDIA_SOURCE_WRONGSTATE  _HRESULT_TYPEDEF_(0xC00D3E9BL)
#define MF_E_MEDIA_SOURCE_NO_STREAMS_SELECTED _HRESULT_TYPEDEF_(0xC00D3E9CL)
#define MF_E_CANNOT_FIND_KEYFRAME_SAMPLE _HRESULT_TYPEDEF_(0xC00D3E9DL)

#define MF_E_NETWORK_RESOURCE_FAILURE  _HRESULT_TYPEDEF_(0xC00D4268L)
#define MF_E_NET_WRITE  _HRESULT_TYPEDEF_(0xC00D4269L)
#define MF_E_NET_READ  _HRESULT_TYPEDEF_(0xC00D426AL)
#define MF_E_NET_REQUIRE_NETWORK  _HRESULT_TYPEDEF_(0xC00D426BL)
#define MF_E_NET_REQUIRE_ASYNC  _HRESULT_TYPEDEF_(0xC00D426CL)
#define MF_E_NET_BWLEVEL_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0xC00D426DL)
#define MF_E_NET_STREAMGROUPS_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC00D426EL)
#define MF_E_NET_MANUALSS_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0xC00D426FL)
#define MF_E_NET_INVALID_PRESENTATION_DESCRIPTOR _HRESULT_TYPEDEF_(0xC00D4270L)
#define MF_E_NET_CACHESTREAM_NOT_FOUND  _HRESULT_TYPEDEF_(0xC00D4271L)
#define MF_I_MANUAL_PROXY  _HRESULT_TYPEDEF_(0x400D4272L)
#define MF_E_NET_REQUIRE_INPUT  _HRESULT_TYPEDEF_(0xC00D4274L)
#define MF_E_NET_REDIRECT  _HRESULT_TYPEDEF_(0xC00D4275L)
#define MF_E_NET_REDIRECT_TO_PROXY  _HRESULT_TYPEDEF_(0xC00D4276L)
#define MF_E_NET_TOO_MANY_REDIRECTS  _HRESULT_TYPEDEF_(0xC00D4277L)
#define MF_E_NET_TIMEOUT  _HRESULT_TYPEDEF_(0xC00D4278L)
#define MF_E_NET_CLIENT_CLOSE  _HRESULT_TYPEDEF_(0xC00D4279L)
#define MF_E_NET_BAD_CONTROL_DATA  _HRESULT_TYPEDEF_(0xC00D427AL)
#define MF_E_NET_INCOMPATIBLE_SERVER  _HRESULT_TYPEDEF_(0xC00D427BL)
#define MF_E_NET_UNSAFE_URL  _HRESULT_TYPEDEF_(0xC00D427CL)
#define MF_E_NET_CACHE_NO_DATA  _HRESULT_TYPEDEF_(0xC00D427DL)
#define MF_E_NET_EOL  _HRESULT_TYPEDEF_(0xC00D427EL)
#define MF_E_NET_BAD_REQUEST  _HRESULT_TYPEDEF_(0xC00D427FL)
#define MF_E_NET_INTERNAL_SERVER_ERROR  _HRESULT_TYPEDEF_(0xC00D4280L)
#define MF_E_NET_SESSION_NOT_FOUND  _HRESULT_TYPEDEF_(0xC00D4281L)
#define MF_E_NET_NOCONNECTION  _HRESULT_TYPEDEF_(0xC00D4282L)
#define MF_E_NET_CONNECTION_FAILURE  _HRESULT_TYPEDEF_(0xC00D4283L)
#define MF_E_NET_INCOMPATIBLE_PUSHSERVER _HRESULT_TYPEDEF_(0xC00D4284L)
#define MF_E_NET_SERVER_ACCESSDENIED  _HRESULT_TYPEDEF_(0xC00D4285L)
#define MF_E_NET_PROXY_ACCESSDENIED  _HRESULT_TYPEDEF_(0xC00D4286L)
#define MF_E_NET_CANNOTCONNECT  _HRESULT_TYPEDEF_(0xC00D4287L)
#define MF_E_NET_INVALID_PUSH_TEMPLATE  _HRESULT_TYPEDEF_(0xC00D4288L)
#define MF_E_NET_INVALID_PUSH_PUBLISHING_POINT _HRESULT_TYPEDEF_(0xC00D4289L)
#define MF_E_NET_BUSY  _HRESULT_TYPEDEF_(0xC00D428AL)
#define MF_E_NET_RESOURCE_GONE  _HRESULT_TYPEDEF_(0xC00D428BL)
#define MF_E_NET_ERROR_FROM_PROXY  _HRESULT_TYPEDEF_(0xC00D428CL)
#define MF_E_NET_PROXY_TIMEOUT  _HRESULT_TYPEDEF_(0xC00D428DL)
#define MF_E_NET_SERVER_UNAVAILABLE  _HRESULT_TYPEDEF_(0xC00D428EL)
#define MF_E_NET_TOO_MUCH_DATA  _HRESULT_TYPEDEF_(0xC00D428FL)
#define MF_E_NET_SESSION_INVALID  _HRESULT_TYPEDEF_(0xC00D4290L)
#define MF_E_OFFLINE_MODE  _HRESULT_TYPEDEF_(0xC00D4291L)
#define MF_E_NET_UDP_BLOCKED  _HRESULT_TYPEDEF_(0xC00D4292L)
#define MF_E_NET_UNSUPPORTED_CONFIGURATION _HRESULT_TYPEDEF_(0xC00D4293L)
#define MF_E_NET_PROTOCOL_DISABLED  _HRESULT_TYPEDEF_(0xC00D4294L)

#define MF_E_ALREADY_INITIALIZED  _HRESULT_TYPEDEF_(0xC00D4650L)
#define MF_E_BANDWIDTH_OVERRUN  _HRESULT_TYPEDEF_(0xC00D4651L)
#define MF_E_LATE_SAMPLE  _HRESULT_TYPEDEF_(0xC00D4652L)
#define MF_E_FLUSH_NEEDED  _HRESULT_TYPEDEF_(0xC00D4653L)
#define MF_E_INVALID_PROFILE  _HRESULT_TYPEDEF_(0xC00D4654L)
#define MF_E_INDEX_NOT_COMMITTED  _HRESULT_TYPEDEF_(0xC00D4655L)
#define MF_E_NO_INDEX  _HRESULT_TYPEDEF_(0xC00D4656L)
#define MF_E_CANNOT_INDEX_IN_PLACE  _HRESULT_TYPEDEF_(0xC00D4657L)
#define MF_E_MISSING_ASF_LEAKYBUCKET  _HRESULT_TYPEDEF_(0xC00D4658L)
#define MF_E_INVALID_ASF_STREAMID  _HRESULT_TYPEDEF_(0xC00D4659L)

#define MF_E_STREAMSINK_REMOVED  _HRESULT_TYPEDEF_(0xC00D4A38L)
#define MF_E_STREAMSINKS_OUT_OF_SYNC  _HRESULT_TYPEDEF_(0xC00D4A3AL)
#define MF_E_STREAMSINKS_FIXED  _HRESULT_TYPEDEF_(0xC00D4A3BL)
#define MF_E_STREAMSINK_EXISTS  _HRESULT_TYPEDEF_(0xC00D4A3CL)
#define MF_E_SAMPLEALLOCATOR_CANCELED  _HRESULT_TYPEDEF_(0xC00D4A3DL)
#define MF_E_SAMPLEALLOCATOR_EMPTY  _HRESULT_TYPEDEF_(0xC00D4A3EL)
#define MF_E_SINK_ALREADYSTOPPED  _HRESULT_TYPEDEF_(0xC00D4A3FL)
#define MF_E_ASF_FILESINK_BITRATE_UNKNOWN _HRESULT_TYPEDEF_(0xC00D4A40L)
#define MF_E_SINK_NO_STREAMS  _HRESULT_TYPEDEF_(0xC00D4A41L)
#define MF_S_SINK_NOT_FINALIZED  _HRESULT_TYPEDEF_(0x000D4A42L)
#define MF_E_METADATA_TOO_LONG  _HRESULT_TYPEDEF_(0xC00D4A43L)
#define MF_E_SINK_NO_SAMPLES_PROCESSED  _HRESULT_TYPEDEF_(0xC00D4A44L)

#define MF_E_VIDEO_REN_NO_PROCAMP_HW  _HRESULT_TYPEDEF_(0xC00D4E20L)
#define MF_E_VIDEO_REN_NO_DEINTERLACE_HW _HRESULT_TYPEDEF_(0xC00D4E21L)
#define MF_E_VIDEO_REN_COPYPROT_FAILED  _HRESULT_TYPEDEF_(0xC00D4E22L)
#define MF_E_VIDEO_REN_SURFACE_NOT_SHARED _HRESULT_TYPEDEF_(0xC00D4E23L)
#define MF_E_VIDEO_DEVICE_LOCKED  _HRESULT_TYPEDEF_(0xC00D4E24L)
#define MF_E_NEW_VIDEO_DEVICE  _HRESULT_TYPEDEF_(0xC00D4E25L)
#define MF_E_NO_VIDEO_SAMPLE_AVAILABLE  _HRESULT_TYPEDEF_(0xC00D4E26L)
#define MF_E_NO_AUDIO_PLAYBACK_DEVICE  _HRESULT_TYPEDEF_(0xC00D4E84L)
#define MF_E_AUDIO_PLAYBACK_DEVICE_IN_USE _HRESULT_TYPEDEF_(0xC00D4E85L)
#define MF_E_AUDIO_PLAYBACK_DEVICE_INVALIDATED _HRESULT_TYPEDEF_(0xC00D4E86L)
#define MF_E_AUDIO_SERVICE_NOT_RUNNING  _HRESULT_TYPEDEF_(0xC00D4E87L)

#define MF_E_TOPO_INVALID_OPTIONAL_NODE  _HRESULT_TYPEDEF_(0xC00D520EL)
#define MF_E_TOPO_CANNOT_FIND_DECRYPTOR  _HRESULT_TYPEDEF_(0xC00D5211L)
#define MF_E_TOPO_CODEC_NOT_FOUND  _HRESULT_TYPEDEF_(0xC00D5212L)
#define MF_E_TOPO_CANNOT_CONNECT  _HRESULT_TYPEDEF_(0xC00D5213L)
#define MF_E_TOPO_UNSUPPORTED  _HRESULT_TYPEDEF_(0xC00D5214L)
#define MF_E_TOPO_INVALID_TIME_ATTRIBUTES _HRESULT_TYPEDEF_(0xC00D5215L)
#define MF_E_TOPO_LOOPS_IN_TOPOLOGY  _HRESULT_TYPEDEF_(0xC00D5216L)
#define MF_E_TOPO_MISSING_PRESENTATION_DESCRIPTOR _HRESULT_TYPEDEF_(0xC00D5217L)
#define MF_E_TOPO_MISSING_STREAM_DESCRIPTOR _HRESULT_TYPEDEF_(0xC00D5218L)
#define MF_E_TOPO_STREAM_DESCRIPTOR_NOT_SELECTED _HRESULT_TYPEDEF_(0xC00D5219L)
#define MF_E_TOPO_MISSING_SOURCE  _HRESULT_TYPEDEF_(0xC00D521AL)
#define MF_E_TOPO_SINK_ACTIVATES_UNSUPPORTED _HRESULT_TYPEDEF_(0xC00D521BL)

#define MF_E_SEQUENCER_UNKNOWN_SEGMENT_ID _HRESULT_TYPEDEF_(0xC00D61ACL)
#define MF_S_SEQUENCER_CONTEXT_CANCELED  _HRESULT_TYPEDEF_(0x000D61ADL)
#define MF_E_NO_SOURCE_IN_CACHE  _HRESULT_TYPEDEF_(0xC00D61AEL)
#define MF_S_SEQUENCER_SEGMENT_AT_END_OF_STREAM _HRESULT_TYPEDEF_(0x000D61AFL)

#define MF_E_TRANSFORM_TYPE_NOT_SET  _HRESULT_TYPEDEF_(0xC00D6D60L)
#define MF_E_TRANSFORM_STREAM_CHANGE  _HRESULT_TYPEDEF_(0xC00D6D61L)
#define MF_E_TRANSFORM_INPUT_REMAINING  _HRESULT_TYPEDEF_(0xC00D6D62L)
#define MF_E_TRANSFORM_PROFILE_MISSING  _HRESULT_TYPEDEF_(0xC00D6D63L)
#define MF_E_TRANSFORM_PROFILE_INVALID_OR_CORRUPT _HRESULT_TYPEDEF_(0xC00D6D64L)
#define MF_E_TRANSFORM_PROFILE_TRUNCATED _HRESULT_TYPEDEF_(0xC00D6D65L)
#define MF_E_TRANSFORM_PROPERTY_PID_NOT_RECOGNIZED _HRESULT_TYPEDEF_(0xC00D6D66L)
#define MF_E_TRANSFORM_PROPERTY_VARIANT_TYPE_WRONG _HRESULT_TYPEDEF_(0xC00D6D67L)
#define MF_E_TRANSFORM_PROPERTY_NOT_WRITEABLE _HRESULT_TYPEDEF_(0xC00D6D68L)
#define MF_E_TRANSFORM_PROPERTY_ARRAY_VALUE_WRONG_NUM_DIM _HRESULT_TYPEDEF_(0xC00D6D69L)
#define MF_E_TRANSFORM_PROPERTY_VALUE_SIZE_WRONG _HRESULT_TYPEDEF_(0xC00D6D6AL)
#define MF_E_TRANSFORM_PROPERTY_VALUE_OUT_OF_RANGE _HRESULT_TYPEDEF_(0xC00D6D6BL)
#define MF_E_TRANSFORM_PROPERTY_VALUE_INCOMPATIBLE _HRESULT_TYPEDEF_(0xC00D6D6CL)
#define MF_E_TRANSFORM_NOT_POSSIBLE_FOR_CURRENT_OUTPUT_MEDIATYPE _HRESULT_TYPEDEF_(0xC00D6D6DL)
#define MF_E_TRANSFORM_NOT_POSSIBLE_FOR_CURRENT_INPUT_MEDIATYPE _HRESULT_TYPEDEF_(0xC00D6D6EL)
#define MF_E_TRANSFORM_NOT_POSSIBLE_FOR_CURRENT_MEDIATYPE_COMBINATION _HRESULT_TYPEDEF_(0xC00D6D6FL)
#define MF_E_TRANSFORM_CONFLICTS_WITH_OTHER_CURRENTLY_ENABLED_FEATURES _HRESULT_TYPEDEF_(0xC00D6D70L)
#define MF_E_TRANSFORM_NEED_MORE_INPUT  _HRESULT_TYPEDEF_(0xC00D6D72L)
#define MF_E_TRANSFORM_NOT_POSSIBLE_FOR_CURRENT_SPKR_CONFIG _HRESULT_TYPEDEF_(0xC00D6D73L)
#define MF_E_TRANSFORM_CANNOT_CHANGE_MEDIATYPE_WHILE_PROCESSING _HRESULT_TYPEDEF_(0xC00D6D74L)
#define MF_S_TRANSFORM_DO_NOT_PROPAGATE_EVENT _HRESULT_TYPEDEF_(0x000D6D75L)
#define MF_E_UNSUPPORTED_D3D_TYPE  _HRESULT_TYPEDEF_(0xC00D6D76L)
#define MF_E_TRANSFORM_ASYNC_LOCKED  _HRESULT_TYPEDEF_(0xC00D6D77L)
#define MF_E_TRANSFORM_CANNOT_INITIALIZE_ACM_DRIVER _HRESULT_TYPEDEF_(0xC00D6D78L)

#define MF_E_LICENSE_INCORRECT_RIGHTS  _HRESULT_TYPEDEF_(0xC00D7148L)
#define MF_E_LICENSE_OUTOFDATE  _HRESULT_TYPEDEF_(0xC00D7149L)
#define MF_E_LICENSE_REQUIRED  _HRESULT_TYPEDEF_(0xC00D714AL)
#define MF_E_DRM_HARDWARE_INCONSISTENT  _HRESULT_TYPEDEF_(0xC00D714BL)
#define MF_E_NO_CONTENT_PROTECTION_MANAGER _HRESULT_TYPEDEF_(0xC00D714CL)
#define MF_E_LICENSE_RESTORE_NO_RIGHTS  _HRESULT_TYPEDEF_(0xC00D714DL)
#define MF_E_BACKUP_RESTRICTED_LICENSE  _HRESULT_TYPEDEF_(0xC00D714EL)
#define MF_E_LICENSE_RESTORE_NEEDS_INDIVIDUALIZATION _HRESULT_TYPEDEF_(0xC00D714FL)
#define MF_S_PROTECTION_NOT_REQUIRED  _HRESULT_TYPEDEF_(0x000D7150L)
#define MF_E_COMPONENT_REVOKED  _HRESULT_TYPEDEF_(0xC00D7151L)
#define MF_E_TRUST_DISABLED  _HRESULT_TYPEDEF_(0xC00D7152L)
#define MF_E_WMDRMOTA_NO_ACTION  _HRESULT_TYPEDEF_(0xC00D7153L)
#define MF_E_WMDRMOTA_ACTION_ALREADY_SET _HRESULT_TYPEDEF_(0xC00D7154L)
#define MF_E_WMDRMOTA_DRM_HEADER_NOT_AVAILABLE _HRESULT_TYPEDEF_(0xC00D7155L)
#define MF_E_WMDRMOTA_DRM_ENCRYPTION_SCHEME_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC00D7156L)
#define MF_E_WMDRMOTA_ACTION_MISMATCH  _HRESULT_TYPEDEF_(0xC00D7157L)
#define MF_E_WMDRMOTA_INVALID_POLICY  _HRESULT_TYPEDEF_(0xC00D7158L)
#define MF_E_POLICY_UNSUPPORTED  _HRESULT_TYPEDEF_(0xC00D7159L)
#define MF_E_OPL_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0xC00D715AL)
#define MF_E_TOPOLOGY_VERIFICATION_FAILED _HRESULT_TYPEDEF_(0xC00D715BL)
#define MF_E_SIGNATURE_VERIFICATION_FAILED _HRESULT_TYPEDEF_(0xC00D715CL)
#define MF_E_DEBUGGING_NOT_ALLOWED  _HRESULT_TYPEDEF_(0xC00D715DL)
#define MF_E_CODE_EXPIRED  _HRESULT_TYPEDEF_(0xC00D715EL)
#define MF_E_GRL_VERSION_TOO_LOW  _HRESULT_TYPEDEF_(0xC00D715FL)
#define MF_E_GRL_RENEWAL_NOT_FOUND  _HRESULT_TYPEDEF_(0xC00D7160L)
#define MF_E_GRL_EXTENSIBLE_ENTRY_NOT_FOUND _HRESULT_TYPEDEF_(0xC00D7161L)
#define MF_E_KERNEL_UNTRUSTED  _HRESULT_TYPEDEF_(0xC00D7162L)
#define MF_E_PEAUTH_UNTRUSTED  _HRESULT_TYPEDEF_(0xC00D7163L)
#define MF_E_NON_PE_PROCESS  _HRESULT_TYPEDEF_(0xC00D7165L)
#define MF_E_REBOOT_REQUIRED  _HRESULT_TYPEDEF_(0xC00D7167L)
#define MF_S_WAIT_FOR_POLICY_SET  _HRESULT_TYPEDEF_(0x000D7168L)
#define MF_S_VIDEO_DISABLED_WITH_UNKNOWN_SOFTWARE_OUTPUT _HRESULT_TYPEDEF_(0x000D7169L)
#define MF_E_GRL_INVALID_FORMAT  _HRESULT_TYPEDEF_(0xC00D716AL)
#define MF_E_GRL_UNRECOGNIZED_FORMAT  _HRESULT_TYPEDEF_(0xC00D716BL)
#define MF_E_ALL_PROCESS_RESTART_REQUIRED _HRESULT_TYPEDEF_(0xC00D716CL)
#define MF_E_PROCESS_RESTART_REQUIRED  _HRESULT_TYPEDEF_(0xC00D716DL)
#define MF_E_USERMODE_UNTRUSTED  _HRESULT_TYPEDEF_(0xC00D716EL)
#define MF_E_PEAUTH_SESSION_NOT_STARTED  _HRESULT_TYPEDEF_(0xC00D716FL)
#define MF_E_PEAUTH_PUBLICKEY_REVOKED  _HRESULT_TYPEDEF_(0xC00D7171L)
#define MF_E_GRL_ABSENT  _HRESULT_TYPEDEF_(0xC00D7172L)
#define MF_S_PE_TRUSTED  _HRESULT_TYPEDEF_(0x000D7173L)
#define MF_E_PE_UNTRUSTED  _HRESULT_TYPEDEF_(0xC00D7174L)
#define MF_E_PEAUTH_NOT_STARTED  _HRESULT_TYPEDEF_(0xC00D7175L)
#define MF_E_INCOMPATIBLE_SAMPLE_PROTECTION _HRESULT_TYPEDEF_(0xC00D7176L)
#define MF_E_PE_SESSIONS_MAXED  _HRESULT_TYPEDEF_(0xC00D7177L)
#define MF_E_HIGH_SECURITY_LEVEL_CONTENT_NOT_ALLOWED _HRESULT_TYPEDEF_(0xC00D7178L)
#define MF_E_TEST_SIGNED_COMPONENTS_NOT_ALLOWED _HRESULT_TYPEDEF_(0xC00D7179L)
#define MF_E_ITA_UNSUPPORTED_ACTION  _HRESULT_TYPEDEF_(0xC00D717AL)
#define MF_E_ITA_ERROR_PARSING_SAP_PARAMETERS _HRESULT_TYPEDEF_(0xC00D717BL)
#define MF_E_POLICY_MGR_ACTION_OUTOFBOUNDS _HRESULT_TYPEDEF_(0xC00D717CL)
#define MF_E_BAD_OPL_STRUCTURE_FORMAT  _HRESULT_TYPEDEF_(0xC00D717DL)
#define MF_E_ITA_UNRECOGNIZED_ANALOG_VIDEO_PROTECTION_GUID _HRESULT_TYPEDEF_(0xC00D717EL)
#define MF_E_NO_PMP_HOST  _HRESULT_TYPEDEF_(0xC00D717FL)
#define MF_E_ITA_OPL_DATA_NOT_INITIALIZED _HRESULT_TYPEDEF_(0xC00D7180L)
#define MF_E_ITA_UNRECOGNIZED_ANALOG_VIDEO_OUTPUT _HRESULT_TYPEDEF_(0xC00D7181L)
#define MF_E_ITA_UNRECOGNIZED_DIGITAL_VIDEO_OUTPUT _HRESULT_TYPEDEF_(0xC00D7182L)

#define MF_E_CLOCK_INVALID_CONTINUITY_KEY _HRESULT_TYPEDEF_(0xC00D9C40L)
#define MF_E_CLOCK_NO_TIME_SOURCE  _HRESULT_TYPEDEF_(0xC00D9C41L)
#define MF_E_CLOCK_STATE_ALREADY_SET  _HRESULT_TYPEDEF_(0xC00D9C42L)
#define MF_E_CLOCK_NOT_SIMPLE  _HRESULT_TYPEDEF_(0xC00D9C43L)
#define MF_S_CLOCK_STOPPED  _HRESULT_TYPEDEF_(0x000D9C44L)

#define MF_E_NO_MORE_DROP_MODES  _HRESULT_TYPEDEF_(0xC00DA028L)
#define MF_E_NO_MORE_QUALITY_LEVELS  _HRESULT_TYPEDEF_(0xC00DA029L)
#define MF_E_DROPTIME_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0xC00DA02AL)
#define MF_E_QUALITYKNOB_WAIT_LONGER  _HRESULT_TYPEDEF_(0xC00DA02BL)
#define MF_E_QM_INVALIDSTATE  _HRESULT_TYPEDEF_(0xC00DA02CL)

#define MF_E_TRANSCODE_NO_CONTAINERTYPE  _HRESULT_TYPEDEF_(0xC00DA410L)
#define MF_E_TRANSCODE_PROFILE_NO_MATCHING_STREAMS _HRESULT_TYPEDEF_(0xC00DA411L)
#define MF_E_TRANSCODE_NO_MATCHING_ENCODER _HRESULT_TYPEDEF_(0xC00DA412L)

#define MF_E_ALLOCATOR_NOT_INITIALIZED  _HRESULT_TYPEDEF_(0xC00DA7F8L)
#define MF_E_ALLOCATOR_NOT_COMMITED  _HRESULT_TYPEDEF_(0xC00DA7F9L)
#define MF_E_ALLOCATOR_ALREADY_COMMITED  _HRESULT_TYPEDEF_(0xC00DA7FAL)
#define MF_E_STREAM_ERROR  _HRESULT_TYPEDEF_(0xC00DA7FBL)
#define MF_E_INVALID_STREAM_STATE  _HRESULT_TYPEDEF_(0xC00DA7FCL)
#define MF_E_HW_STREAM_NOT_CONNECTED  _HRESULT_TYPEDEF_(0xC00DA7FDL)

#endif /* _MFERROR_H */
