#ifndef _RPCNTERR_H
#define _RPCNTERR_H

#ifdef __ORANGEC__ 
#pragma once
#endif

/* Windows RPC error code definitions */

#if !defined(_KRPCENV_)

#define RPC_S_OK  ERROR_SUCCESS
#define RPC_S_INVALID_ARG  ERROR_INVALID_PARAMETER
#define RPC_S_OUT_OF_MEMORY  ERROR_OUTOFMEMORY
#define RPC_S_OUT_OF_THREADS  ERROR_MAX_THRDS_REACHED
#define RPC_S_INVALID_LEVEL  ERROR_INVALID_PARAMETER
#define RPC_S_BUFFER_TOO_SMALL  ERROR_INSUFFICIENT_BUFFER
#define RPC_S_INVALID_SECURITY_DESC  ERROR_INVALID_SECURITY_DESCR
#define RPC_S_ACCESS_DENIED  ERROR_ACCESS_DENIED
#define RPC_S_SERVER_OUT_OF_MEMORY  ERROR_NOT_ENOUGH_SERVER_MEMORY
#define RPC_S_ASYNC_CALL_PENDING  ERROR_IO_PENDING
#define RPC_S_UNKNOWN_PRINCIPAL  ERROR_NONE_MAPPED
#define RPC_S_TIMEOUT  ERROR_TIMEOUT
#if (NTDDI_VERSION >= NTDDI_VISTA)
#define RPC_S_NOT_ENOUGH_QUOTA  ERROR_NOT_ENOUGH_QUOTA
#endif /* NTDDI_VERSION >= NTDDI_VISTA */

#define RPC_X_NO_MEMORY  RPC_S_OUT_OF_MEMORY
#define RPC_X_INVALID_BOUND  RPC_S_INVALID_BOUND
#define RPC_X_INVALID_TAG  RPC_S_INVALID_TAG
#define RPC_X_ENUM_VALUE_TOO_LARGE  RPC_X_ENUM_VALUE_OUT_OF_RANGE
#define RPC_X_SS_CONTEXT_MISMATCH  ERROR_INVALID_HANDLE
#define RPC_X_INVALID_BUFFER  ERROR_INVALID_USER_BUFFER
#define RPC_X_PIPE_APP_MEMORY  ERROR_OUTOFMEMORY
#define RPC_X_INVALID_PIPE_OPERATION  RPC_X_WRONG_PIPE_ORDER

#else /* _KRPCENV_ */

#define RPC_S_OK  STATUS_SUCCESS

#undef  RPC_S_INVALID_STRING_BINDING
#define RPC_S_INVALID_STRING_BINDING  RPC_NT_INVALID_STRING_BINDING

#undef  RPC_S_WRONG_KIND_OF_BINDING
#define RPC_S_WRONG_KIND_OF_BINDING  RPC_NT_WRONG_KIND_OF_BINDING

#undef  RPC_S_INVALID_BINDING
#define RPC_S_INVALID_BINDING  RPC_NT_INVALID_BINDING

#undef  RPC_S_PROTSEQ_NOT_SUPPORTED
#define RPC_S_PROTSEQ_NOT_SUPPORTED  RPC_NT_PROTSEQ_NOT_SUPPORTED

#undef  RPC_S_INVALID_RPC_PROTSEQ
#define RPC_S_INVALID_RPC_PROTSEQ  RPC_NT_INVALID_RPC_PROTSEQ

#undef  RPC_S_INVALID_STRING_UUID
#define RPC_S_INVALID_STRING_UUID  RPC_NT_INVALID_STRING_UUID

#undef  RPC_S_INVALID_ENDPOINT_FORMAT
#define RPC_S_INVALID_ENDPOINT_FORMAT  RPC_NT_INVALID_ENDPOINT_FORMAT

#undef  RPC_S_INVALID_NET_ADDR
#define RPC_S_INVALID_NET_ADDR  RPC_NT_INVALID_NET_ADDR

#undef  RPC_S_NO_ENDPOINT_FOUND
#define RPC_S_NO_ENDPOINT_FOUND  RPC_NT_NO_ENDPOINT_FOUND

#undef  RPC_S_INVALID_TIMEOUT
#define RPC_S_INVALID_TIMEOUT  RPC_NT_INVALID_TIMEOUT

#undef  RPC_S_OBJECT_NOT_FOUND
#define RPC_S_OBJECT_NOT_FOUND  RPC_NT_OBJECT_NOT_FOUND

#undef  RPC_S_ALREADY_REGISTERED
#define RPC_S_ALREADY_REGISTERED  RPC_NT_ALREADY_REGISTERED

#undef  RPC_S_TYPE_ALREADY_REGISTERED
#define RPC_S_TYPE_ALREADY_REGISTERED  RPC_NT_TYPE_ALREADY_REGISTERED

#undef  RPC_S_ALREADY_LISTENING
#define RPC_S_ALREADY_LISTENING  RPC_NT_ALREADY_LISTENING

#undef  RPC_S_NO_PROTSEQS_REGISTERED
#define RPC_S_NO_PROTSEQS_REGISTERED  RPC_NT_NO_PROTSEQS_REGISTERED

#undef  RPC_S_NOT_LISTENING
#define RPC_S_NOT_LISTENING  RPC_NT_NOT_LISTENING

#undef  RPC_S_UNKNOWN_MGR_TYPE
#define RPC_S_UNKNOWN_MGR_TYPE  RPC_NT_UNKNOWN_MGR_TYPE

#undef  RPC_S_UNKNOWN_IF
#define RPC_S_UNKNOWN_IF  RPC_NT_UNKNOWN_IF

#undef  RPC_S_NO_BINDINGS
#define RPC_S_NO_BINDINGS  RPC_NT_NO_BINDINGS

#undef  RPC_S_NO_MORE_BINDINGS
#define RPC_S_NO_MORE_BINDINGS  RPC_NT_NO_MORE_BINDINGS

#undef  RPC_S_NO_PROTSEQS
#define RPC_S_NO_PROTSEQS  RPC_NT_NO_PROTSEQS

#undef  RPC_S_CANT_CREATE_ENDPOINT
#define RPC_S_CANT_CREATE_ENDPOINT  RPC_NT_CANT_CREATE_ENDPOINT

#undef  RPC_S_OUT_OF_RESOURCES
#define RPC_S_OUT_OF_RESOURCES  RPC_NT_OUT_OF_RESOURCES

#undef  RPC_S_SERVER_UNAVAILABLE
#define RPC_S_SERVER_UNAVAILABLE  RPC_NT_SERVER_UNAVAILABLE

#undef  RPC_S_SERVER_TOO_BUSY
#define RPC_S_SERVER_TOO_BUSY  RPC_NT_SERVER_TOO_BUSY

#undef  RPC_S_INVALID_NETWORK_OPTIONS
#define RPC_S_INVALID_NETWORK_OPTIONS  RPC_NT_INVALID_NETWORK_OPTIONS

#undef  RPC_S_NO_CALL_ACTIVE
#define RPC_S_NO_CALL_ACTIVE  RPC_NT_NO_CALL_ACTIVE

#undef  RPC_S_CALL_FAILED
#define RPC_S_CALL_FAILED  RPC_NT_CALL_FAILED

#undef  RPC_S_CALL_CANCELLED
#define RPC_S_CALL_CANCELLED  RPC_NT_CALL_CANCELLED

#undef  RPC_S_CALL_FAILED_DNE
#define RPC_S_CALL_FAILED_DNE  RPC_NT_CALL_FAILED_DNE

#undef  RPC_S_PROTOCOL_ERROR
#define RPC_S_PROTOCOL_ERROR  RPC_NT_PROTOCOL_ERROR

#undef  RPC_S_UNSUPPORTED_TRANS_SYN
#define RPC_S_UNSUPPORTED_TRANS_SYN  RPC_NT_UNSUPPORTED_TRANS_SYN

#undef  RPC_S_SERVER_OUT_OF_MEMORY
#define RPC_S_SERVER_OUT_OF_MEMORY  STATUS_INSUFF_SERVER_RESOURCES

#undef  RPC_S_UNSUPPORTED_TYPE
#define RPC_S_UNSUPPORTED_TYPE  RPC_NT_UNSUPPORTED_TYPE

#undef  RPC_S_INVALID_TAG
#define RPC_S_INVALID_TAG  RPC_NT_INVALID_TAG

#undef  RPC_S_INVALID_BOUND
#define RPC_S_INVALID_BOUND  RPC_NT_INVALID_BOUND

#undef  RPC_S_NO_ENTRY_NAME
#define RPC_S_NO_ENTRY_NAME  RPC_NT_NO_ENTRY_NAME

#undef  RPC_S_INVALID_NAME_SYNTAX
#define RPC_S_INVALID_NAME_SYNTAX  RPC_NT_INVALID_NAME_SYNTAX

#undef  RPC_S_UNSUPPORTED_NAME_SYNTAX
#define RPC_S_UNSUPPORTED_NAME_SYNTAX  RPC_NT_UNSUPPORTED_NAME_SYNTAX

#undef  RPC_S_UUID_NO_ADDRESS
#define RPC_S_UUID_NO_ADDRESS  RPC_NT_UUID_NO_ADDRESS

#undef  RPC_S_DUPLICATE_ENDPOINT
#define RPC_S_DUPLICATE_ENDPOINT  RPC_NT_DUPLICATE_ENDPOINT

#undef  RPC_S_UNKNOWN_AUTHN_TYPE
#define RPC_S_UNKNOWN_AUTHN_TYPE  RPC_NT_UNKNOWN_AUTHN_TYPE

#undef  RPC_S_MAX_CALLS_TOO_SMALL
#define RPC_S_MAX_CALLS_TOO_SMALL  RPC_NT_MAX_CALLS_TOO_SMALL

#undef  RPC_S_STRING_TOO_LONG
#define RPC_S_STRING_TOO_LONG  RPC_NT_STRING_TOO_LONG

#undef  RPC_S_PROTSEQ_NOT_FOUND
#define RPC_S_PROTSEQ_NOT_FOUND  RPC_NT_PROTSEQ_NOT_FOUND

#undef  RPC_S_PROCNUM_OUT_OF_RANGE
#define RPC_S_PROCNUM_OUT_OF_RANGE  RPC_NT_PROCNUM_OUT_OF_RANGE

#undef  RPC_S_BINDING_HAS_NO_AUTH
#define RPC_S_BINDING_HAS_NO_AUTH  RPC_NT_BINDING_HAS_NO_AUTH

#undef  RPC_S_UNKNOWN_AUTHN_SERVICE
#define RPC_S_UNKNOWN_AUTHN_SERVICE  RPC_NT_UNKNOWN_AUTHN_SERVICE

#undef  RPC_S_UNKNOWN_AUTHN_LEVEL
#define RPC_S_UNKNOWN_AUTHN_LEVEL  RPC_NT_UNKNOWN_AUTHN_LEVEL

#undef  RPC_S_INVALID_AUTH_IDENTITY
#define RPC_S_INVALID_AUTH_IDENTITY  RPC_NT_INVALID_AUTH_IDENTITY

#undef  RPC_S_UNKNOWN_AUTHZ_SERVICE
#define RPC_S_UNKNOWN_AUTHZ_SERVICE  RPC_NT_UNKNOWN_AUTHZ_SERVICE

#undef  EPT_S_INVALID_ENTRY
#define EPT_S_INVALID_ENTRY  EPT_NT_INVALID_ENTRY

#undef  EPT_S_CANT_PERFORM_OP
#define EPT_S_CANT_PERFORM_OP  EPT_NT_CANT_PERFORM_OP

#undef  EPT_S_NOT_REGISTERED
#define EPT_S_NOT_REGISTERED  EPT_NT_NOT_REGISTERED

#undef  RPC_S_NOTHING_TO_EXPORT
#define RPC_S_NOTHING_TO_EXPORT  RPC_NT_NOTHING_TO_EXPORT

#undef  RPC_S_INCOMPLETE_NAME
#define RPC_S_INCOMPLETE_NAME  RPC_NT_INCOMPLETE_NAME

#undef  RPC_S_INVALID_VERS_OPTION
#define RPC_S_INVALID_VERS_OPTION  RPC_NT_INVALID_VERS_OPTION

#undef  RPC_S_NO_MORE_MEMBERS
#define RPC_S_NO_MORE_MEMBERS  RPC_NT_NO_MORE_MEMBERS

#undef  RPC_S_NOT_ALL_OBJS_UNEXPORTED
#define RPC_S_NOT_ALL_OBJS_UNEXPORTED  RPC_NT_NOT_ALL_OBJS_UNEXPORTED

#undef  RPC_S_INTERFACE_NOT_FOUND
#define RPC_S_INTERFACE_NOT_FOUND  RPC_NT_INTERFACE_NOT_FOUND

#undef  RPC_S_ENTRY_ALREADY_EXISTS
#define RPC_S_ENTRY_ALREADY_EXISTS  RPC_NT_ENTRY_ALREADY_EXISTS

#undef  RPC_S_ENTRY_NOT_FOUND
#define RPC_S_ENTRY_NOT_FOUND  RPC_NT_ENTRY_NOT_FOUND

#undef  RPC_S_NAME_SERVICE_UNAVAILABLE
#define RPC_S_NAME_SERVICE_UNAVAILABLE  RPC_NT_NAME_SERVICE_UNAVAILABLE

#undef  RPC_S_INVALID_NAF_ID
#define RPC_S_INVALID_NAF_ID  RPC_NT_INVALID_NAF_ID

#undef  RPC_S_CANNOT_SUPPORT
#define RPC_S_CANNOT_SUPPORT  RPC_NT_CANNOT_SUPPORT

#undef  RPC_S_NO_CONTEXT_AVAILABLE
#define RPC_S_NO_CONTEXT_AVAILABLE  RPC_NT_NO_CONTEXT_AVAILABLE

#undef  RPC_S_INTERNAL_ERROR
#define RPC_S_INTERNAL_ERROR  RPC_NT_INTERNAL_ERROR

#undef  RPC_S_ZERO_DIVIDE
#define RPC_S_ZERO_DIVIDE  RPC_NT_ZERO_DIVIDE

#undef  RPC_S_ADDRESS_ERROR
#define RPC_S_ADDRESS_ERROR  RPC_NT_ADDRESS_ERROR

#undef  RPC_S_FP_DIV_ZERO
#define RPC_S_FP_DIV_ZERO  RPC_NT_FP_DIV_ZERO

#undef  RPC_S_FP_UNDERFLOW
#define RPC_S_FP_UNDERFLOW  RPC_NT_FP_UNDERFLOW

#undef  RPC_S_FP_OVERFLOW
#define RPC_S_FP_OVERFLOW  RPC_NT_FP_OVERFLOW

#undef  RPC_S_PROXY_ACCESS_DENIED
#define RPC_S_PROXY_ACCESS_DENIED  RPC_NT_PROXY_ACCESS_DENIED

#undef  RPC_X_NO_MORE_ENTRIES
#define RPC_X_NO_MORE_ENTRIES  RPC_NT_NO_MORE_ENTRIES

#undef  RPC_X_SS_CHAR_TRANS_OPEN_FAIL
#define RPC_X_SS_CHAR_TRANS_OPEN_FAIL  RPC_NT_SS_CHAR_TRANS_OPEN_FAIL

#undef  RPC_X_SS_CHAR_TRANS_SHORT_FILE
#define RPC_X_SS_CHAR_TRANS_SHORT_FILE  RPC_NT_SS_CHAR_TRANS_SHORT_FILE

#undef  RPC_X_SS_IN_NULL_CONTEXT
#define RPC_X_SS_IN_NULL_CONTEXT  RPC_NT_SS_IN_NULL_CONTEXT

#undef  RPC_X_SS_CONTEXT_MISMATCH
#define RPC_X_SS_CONTEXT_MISMATCH  RPC_NT_SS_CONTEXT_MISMATCH

#undef  RPC_X_SS_CONTEXT_DAMAGED
#define RPC_X_SS_CONTEXT_DAMAGED  RPC_NT_SS_CONTEXT_DAMAGED

#undef  RPC_X_SS_HANDLES_MISMATCH
#define RPC_X_SS_HANDLES_MISMATCH  RPC_NT_SS_HANDLES_MISMATCH

#undef  RPC_X_SS_CANNOT_GET_CALL_HANDLE
#define RPC_X_SS_CANNOT_GET_CALL_HANDLE  RPC_NT_SS_CANNOT_GET_CALL_HANDLE

#undef  RPC_X_NULL_REF_POINTER
#define RPC_X_NULL_REF_POINTER  RPC_NT_NULL_REF_POINTER

#undef  RPC_X_ENUM_VALUE_OUT_OF_RANGE
#define RPC_X_ENUM_VALUE_OUT_OF_RANGE  RPC_NT_ENUM_VALUE_OUT_OF_RANGE

#undef  RPC_X_BYTE_COUNT_TOO_SMALL
#define RPC_X_BYTE_COUNT_TOO_SMALL  RPC_NT_BYTE_COUNT_TOO_SMALL

#undef  RPC_X_BAD_STUB_DATA
#define RPC_X_BAD_STUB_DATA  RPC_NT_BAD_STUB_DATA

#undef  RPC_S_CALL_IN_PROGRESS
#define RPC_S_CALL_IN_PROGRESS  RPC_NT_CALL_IN_PROGRESS

#undef  RPC_S_GROUP_MEMBER_NOT_FOUND
#define RPC_S_GROUP_MEMBER_NOT_FOUND  RPC_NT_GROUP_MEMBER_NOT_FOUND

#undef  EPT_S_CANT_CREATE
#define EPT_S_CANT_CREATE  EPT_NT_CANT_CREATE

#undef  RPC_S_INVALID_OBJECT
#define RPC_S_INVALID_OBJECT  RPC_NT_INVALID_OBJECT

#undef  RPC_S_INVALID_ASYNC_HANDLE
#define RPC_S_INVALID_ASYNC_HANDLE  RPC_NT_INVALID_ASYNC_HANDLE

#undef  RPC_S_INVALID_ASYNC_CALL
#define RPC_S_INVALID_ASYNC_CALL  RPC_NT_INVALID_ASYNC_CALL

#undef  RPC_X_PIPE_CLOSED
#define RPC_X_PIPE_CLOSED  RPC_NT_PIPE_CLOSED

#undef  RPC_X_PIPE_EMPTY
#define RPC_X_PIPE_EMPTY  RPC_NT_PIPE_EMPTY

#undef  RPC_X_PIPE_DISCIPLINE_ERROR
#define RPC_X_PIPE_DISCIPLINE_ERROR  RPC_NT_PIPE_DISCIPLINE_ERROR

#define RPC_S_INVALID_ARG  STATUS_INVALID_PARAMETER
#define RPC_S_OUT_OF_MEMORY  STATUS_NO_MEMORY
#define RPC_S_OUT_OF_THREADS  STATUS_NO_MEMORY
#define RPC_S_INVALID_LEVEL  STATUS_INVALID_PARAMETER
#define RPC_S_BUFFER_TOO_SMALL  STATUS_BUFFER_TOO_SMALL
#define RPC_S_INVALID_SECURITY_DESC  STATUS_INVALID_SECURITY_DESCR
#define RPC_S_ACCESS_DENIED  STATUS_ACCESS_DENIED
#define RPC_S_ASYNC_CALL_PENDING  STATUS_PENDING
#define RPC_S_UNKNOWN_PRINCIPAL  STATUS_NONE_MAPPED
#define RPC_S_NOT_ENOUGH_QUOTA  STATUS_QUOTA_EXCEEDED
#define RPC_X_NO_MEMORY  STATUS_NO_MEMORY
#define RPC_X_INVALID_BOUND  RPC_NT_INVALID_BOUND
#define RPC_X_INVALID_TAG  RPC_NT_INVALID_TAG
#define RPC_X_ENUM_VALUE_TOO_LARGE  RPC_NT_ENUM_VALUE_OUT_OF_RANGE
#define RPC_X_SS_CONTEXT_MISMATCH  RPC_NT_SS_CONTEXT_MISMATCH
#define RPC_X_INVALID_BUFFER  STATUS_INVALID_BUFFER_SIZE
#define RPC_X_PIPE_APP_MEMORY  STATUS_NO_MEMORY

#endif /* !defined(_KRPCENV_) */

#endif /* _RPCNTERR_H */
