#ifndef _TIMEZONEAPI_H
#define _TIMEZONEAPI_H

#ifdef __ORANGEC__ 
#pragma once
#endif

/* ApiSet api-ms-win-core-timezone-l1 */

/* #include <apiset.h> */
#include <apisetcconv.h>
#include <minwindef.h>
#include <minwinbase.h>

#define TIME_ZONE_ID_INVALID  ((DWORD)0xFFFFFFFF)

typedef struct _TIME_ZONE_INFORMATION {
    LONG Bias;
    WCHAR StandardName[32];
    SYSTEMTIME StandardDate;
    LONG StandardBias;
    WCHAR DaylightName[32];
    SYSTEMTIME DaylightDate;
    LONG DaylightBias;
} TIME_ZONE_INFORMATION, *PTIME_ZONE_INFORMATION, *LPTIME_ZONE_INFORMATION;

typedef struct _TIME_DYNAMIC_ZONE_INFORMATION {
    LONG Bias;
    WCHAR StandardName[32];
    SYSTEMTIME StandardDate;
    LONG StandardBias;
    WCHAR DaylightName[32];
    SYSTEMTIME DaylightDate;
    LONG DaylightBias;
    WCHAR TimeZoneKeyName[128];
    BOOLEAN DynamicDaylightTimeDisabled;
} DYNAMIC_TIME_ZONE_INFORMATION, *PDYNAMIC_TIME_ZONE_INFORMATION;

WINBASEAPI BOOL WINAPI SystemTimeToTzSpecificLocalTime(CONST TIME_ZONE_INFORMATION *, CONST SYSTEMTIME *, LPSYSTEMTIME);
WINBASEAPI BOOL WINAPI TzSpecificLocalTimeToSystemTime(CONST TIME_ZONE_INFORMATION *, CONST SYSTEMTIME *, LPSYSTEMTIME);
WINBASEAPI BOOL WINAPI FileTimeToSystemTime(CONST FILETIME *, LPSYSTEMTIME);
WINBASEAPI BOOL WINAPI SystemTimeToFileTime(CONST SYSTEMTIME *, LPFILETIME);
WINBASEAPI DWORD WINAPI GetTimeZoneInformation(LPTIME_ZONE_INFORMATION);
WINBASEAPI BOOL WINAPI SetTimeZoneInformation(CONST TIME_ZONE_INFORMATION *);
#if (_WIN32_WINNT >= 0x0600)
WINBASEAPI BOOL WINAPI SetDynamicTimeZoneInformation(CONST DYNAMIC_TIME_ZONE_INFORMATION *);
WINBASEAPI DWORD WINAPI GetDynamicTimeZoneInformation(PDYNAMIC_TIME_ZONE_INFORMATION);
#endif /* _WIN32_WINNT >= 0x0600 */
#if (_WIN32_WINNT >= 0x0601)
BOOL WINAPI GetTimeZoneInformationForYear(USHORT, PDYNAMIC_TIME_ZONE_INFORMATION, LPTIME_ZONE_INFORMATION);
#endif /* _WIN32_WINNT >= 0x0601 */

#if (_WIN32_WINNT >= _WIN32_WINNT_WIN8)
WINBASEAPI DWORD WINAPI EnumDynamicTimeZoneInformation(CONST DWORD, PDYNAMIC_TIME_ZONE_INFORMATION);
WINBASEAPI DWORD WINAPI GetDynamicTimeZoneInformationEffectiveYears(CONST PDYNAMIC_TIME_ZONE_INFORMATION, LPDWORD, LPDWORD);
WINBASEAPI BOOL WINAPI SystemTimeToTzSpecificLocalTimeEx(CONST DYNAMIC_TIME_ZONE_INFORMATION *, CONST SYSTEMTIME *, LPSYSTEMTIME);
WINBASEAPI BOOL WINAPI TzSpecificLocalTimeToSystemTimeEx(CONST DYNAMIC_TIME_ZONE_INFORMATION *, CONST SYSTEMTIME *, LPSYSTEMTIME);
#endif /* _WIN32_WINNT >= _WIN32_WINNT_WIN8 */

#endif /* _TIMEZONEAPI_H */
